require.config({
    baseUrl: "lib",
    waitSeconds: 15
});

define(["devicepass"], function(DevicePass) {
    "use strict";

    var received = false;

    function show_message(msg){
        var div = document.createElement('div');
        div.innerHTML = msg;
        var message = document.getElementById('messages');
        message.appendChild(div);
        message.scrollTop = message.scrollHeight;
    }

    function onDevicePrintReady(info){
        show_message(info.device_print);
		var button = document.getElementById('query_device_print');
		button.disabled = false;
		spinner.style.display = "none";
        received = true;
        popup.style.display = "none";
        hide_prompt();
    }

    function onDeviceAccessDenied(){
        show_message("Access Denied");
		var button = document.getElementById('query_device_print');
		button.disabled = false;
		spinner.style.display = "none";
        received = true;
        popup.style.display = "none";
        hide_prompt();
    }

    function hide_prompt(){
        var container = document.getElementById("iframe_container");
        container.innerHTML = "";
        container.style.display = "none";
    }

    function show_prompt(url){
        var html = "<iframe src=\"" + url + "\" width=\"610\" height=\"430\" frameborder=\"0\">";

        var container = document.getElementById("iframe_container");
        container.innerHTML = html;
        container.style.display = "block";
    }

    function onPopup(url){
        show_prompt(url);
    }

    function onError(e){
        alert("onError");
    }

    function query() {
        var m = document.getElementById('mode');
        var s = document.getElementById('session-id');
		var button = document.getElementById('query_device_print');
		button.disabled = true;
		var spinner = document.getElementById('spinner');
		spinner.style.display = "inline";

        received = false;

        DevicePass.query(s.value, parseInt(m.options[m.selectedIndex].value), false,
            window,
            onDevicePrintReady,
            onDeviceAccessDenied,
            onError,
            onPopup);
    }

    DevicePass.initialize("", function(v){
        show_message("Initialized: " + v);
    },
    function(e){
        show_message(e);
    });

    document.getElementById('query_device_print').onclick = function(ev) {
        query();
    };


});